频道栏目
首页 > 资讯 > C++ > 正文

HDU 4252A Famous City(弱数据可以使用贪心)

13-10-26        来源:[db:作者]  
收藏   我要投稿
A Famous City
Time Limit: 10000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1504    Accepted Submission(s): 563
 
 
Problem Description
After Mr. B arrived in Warsaw, he was shocked by the skyscrapers and took several photos. But now when he looks at these photos, he finds in surprise that he isn't able to point out even the number of buildings in it. So he decides to work it out as follows:
- divide the photo into n vertical pieces from left to right. The buildings in the photo can be treated as rectangles, the lower edge of which is the horizon. One building may span several consecutive pieces, but each piece can only contain one visible building, or no buildings at all.
- measure the height of each building in that piece.
- write a program to calculate the minimum number of buildings.
Mr. B has finished the first two steps, the last comes to you.
 
 
Input
Each test case starts with a line containing an integer n (1 <= n <= 100,000). Following this is a line containing n integers - the height of building in each piece respectively. Note that zero height means there are no buildings in this piece at all. All the input numbers will be nonnegative and less than 1,000,000,000.
 
 
Output
For each test case, display a single line containing the case number and the minimum possible number of buildings in the photo.
 
 
Sample Input
3
1 2 3
3
1 2 1
 
 
Sample Output
Case 1: 3
Case 2: 2
 
Hint
 
The possible configurations of the samples are illustrated below:
 
 
 
 
 
 
Source
Fudan Local Programming Contest 2012
 
 
 
题目大意:把一片房子等分成很多份,每一片有自己的高度,第二张图中间蓝色的被棕色的挡住了。问你最少是多少栋楼。
 
解题思路:开始想错了,直接理解为同一高度的都可以是一栋楼,但是中间如果出现矮的话就不行了,因为挡不住自己可以画一下。后来采用贪心的策略,每个点尽量包含后面多的点。碰到比它高的直接跳过,跟他一样的清零,比他矮的终止。算法的复杂度没有降下来。。可以用rmq降到O(N*LOG(N))
 
题目地址:A Famous City
 
AC代码:
 
#include<iostream>  
#include<cstdio>  
#define maxn 100005  
using namespace std;  
int a[maxn];  
  
int main()  
{  
    int n;  
    int tes=0,i,j,res;  
    while(cin>>n)  
    {  
        res=0;  
        for(i=0;i<n;i++)  
            cin>>a[i];  
        for(i=0;i<n;i++)  
        {  
            if(a[i])  
            {  
                for(j=i+1;j<n;j++)  
                {  
                    if(a[j]==a[i]) a[j]=0;  
                    else if(a[j]<a[i]) break;  
                }  
                res++;  
            }  
        }  
  
        printf("Case %d: %d\n",++tes,res);  
    }  
    return 0;  
}  
  
//468MS  

 

 
 
 
相关TAG标签
上一篇:Win7及Win8系统休眠功能闹罢工怎么办
下一篇:win8默认使用IE浏览器打开QQ空间,通过如下设置可以更改浏览器
相关文章
图文推荐

关于我们 | 联系我们 | 广告服务 | 投资合作 | 版权申明 | 在线帮助 | 网站地图 | 作品发布 | Vip技术培训 | 举报中心

版权所有: 红黑联盟--致力于做实用的IT技术学习网站